//+------------------------------------------------------------------+
//|                                               VininI_CanalZZ.mq4 |
//|                                         Copyright  2011, Vinin. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Vinin."
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Yellow

extern int TimeFrame=0;
extern int Depth=15;
extern int Count=2;

//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ZZValue[];

int trend=0;
int K=1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);

   
   if (TimeFrame>Period()) {
      TimeFrame/=Period();
      TimeFrame*=Period();
      K=TimeFrame/Period();
   } else 
      TimeFrame=Period();

   ArrayResize(ZZValue,Count*2+1);

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()  {
   int i,j,   counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   if (limit>1) limit-=Depth;
   
   for (i=limit;i>=0;i--) {
      int hpos=iHighest(NULL, 0, MODE_HIGH, Depth*K,i);
      int lpos=iLowest( NULL, 0, MODE_LOW,  Depth*K,i);
      double h=High[hpos];
      double l=Low[ lpos];
      if (hpos<lpos) {
         if (trend!=1) {
            for (j=Count*2;j>0;j--)  ZZValue[j]=ZZValue[j-1];
            trend=1;
         } 
         ZZValue[0]=High[hpos];
      } else {
         if (trend!=-1) {
            for (j=Count*2;j>0;j--)  ZZValue[j]=ZZValue[j-1];
            trend=-1;
         } 
         ZZValue[0]=Low[lpos];
      }
      ExtMapBuffer1[i]=0;
      ExtMapBuffer2[i]=0;

      if (ZZValue[1]>ZZValue[2]) {
         for (j=1;j<Count*2;j+=2) {
            ExtMapBuffer1[i]+=ZZValue[j];
            ExtMapBuffer2[i]+=ZZValue[j+1];
         }            
      } else {
         for (j=1;j<Count*2;j+=2) {
            ExtMapBuffer2[i]+=ZZValue[j];
            ExtMapBuffer1[i]+=ZZValue[j+1];
         }            
      }
      ExtMapBuffer2[i]/=Count;
      ExtMapBuffer1[i]/=Count;
      ExtMapBuffer3[i]=(ExtMapBuffer1[i]+ExtMapBuffer2[i])*0.5;
   }
   return(0);
  }
//+------------------------------------------------------------------+